% *********************************************************************
function varargout=recest(ftype,flag,varargin)
% *********************************************************************
% Usage: recest(ftype,0,pred)     % Initialisering
%        xh=recest(ftype,1,y)     % Recursive estimation (in mdl)
%        [xh,St,yht,rest,Rt]=recest(ftype,2); % output of results
% *********************************************************************
switch flag,
% *********************************************************************   
case 0, % Initialisering
 pred=varargin{1};
 switch ftype,
  case 0, klms(0,pred);
  case 1, klm(0,pred);
  case 2, ekf(0,pred);
  case 3, ukf(0,pred);
  case 4, dd1(0,pred);
  case 5, dd2(0,pred);
  case 6, skfp(0,pred);
  case 7, skfb(0,pred);
 otherwise
 end;
% *********************************************************************  
case 1, % Estimation
 y=varargin{1};
 switch ftype,
  case 0, xh=klms(1,y);
  case 1, xh=klm(1,y);
  case 2, xh=ekf(1,y);
  case 3, xh=ukf(1,y);
  case 4, xh=dd1(1,y);
  case 5, xh=dd2(1,y);
  case 6, xh=skfp(1,y); 
  case 7, xh=skfb(1,y);
 otherwise
 end
 varargout(1)={xh};
% *********************************************************************
case 2, % flush results
 switch ftype,
  case 0, [xht,St,yht,rest,Rt]=klms(2);
  case 1, [xht,St,yht,rest,Rt]=klm(2);
  case 2, [xht,St,yht,rest,Rt]=ekf(2);
  case 3, [xht,St,yht,rest,Rt]=ukf(2);
  case 4, [xht,St,yht,rest,Rt]=dd1(2);
  case 5, [xht,St,yht,rest,Rt]=dd2(2);
  case 6, [xht,St,yht,rest,Rt]=skfp(2); 
  case 7, [xht,St,yht,rest,Rt]=skfb(2);
  otherwise
 end;
 varargout={xht; St; yht; rest; Rt};
% *********************************************************************
otherwise
% *********************************************************************
end % flag
