function T=systplz(varargin)
%Determine the toeplitz matrix of the system
%
% Usage T=systplz(A,B,C,D,n)
%       T=systplz(a,b,n)
%
% n: length of impulse response, i.e. i=0, 1, ... n
 
% Programmed 2004 by Niels K. Poulsen 
% Informatics and Mathematical Modelling, 
% Technical University of Denmark 

if nargin>3, 		% State space description
 A=a1; B=a2; C=a3; D=a4;
 [A,B,C,D]=extract(varargin)
 if nargin==4, n=length(A); else, n=a5; end;
else,			% Transfer function description
 [A,B,C,D]=trf2ss(a1,a2,0);
 if nargin==2, n=length(A); else, n=a3; end;
end
ns=length(A);
nu=size(B,2);
ny=size(C,1);

AnB=B;
nuller=zeros(ny,n*nu);
row=[D nuller];
T=row;
for i=1:n,
 row=[C*AnB row(:,1:end-nu)];
 T=[T; row];
 AnB=A*AnB;
end

